# bZ[W̃fR[h
sub message_decode_rtn {
	local($mlist_ref, $message_file, $i, $j, $k, $flg);
	
	$message_file = $_[0];
	
	$mlist_ref = &file_read(MES, $message_file, 0);
	if ($filerr) {	return 'false';	}
	
	chomp(@{$mlist_ref});
	
	&message_initialize_rtn;
	
	$j = 0;
	$flg = 0;
	for ($i = 0; $i <= $#{$mlist_ref}; $i ++) {
		if ($flg == 0) {
			($message_no[$j], $message_id[$j], $message_title[$j], $message_time[$j], $message_flg[$j], $message_ip[$j]) = split(/,/, ${$mlist_ref}[$i]);
			$message_title[$j] =~ s/&comma;/,/g;
			$flg = 1;
			$k = 0;
		} else {
			if (${$mlist_ref}[$i] eq "<>") {
				if ($k == 0) {	$message_length[$j] = 0;	}
				else {	$message_length[$j] = $k - 1;	}
				$j ++;
				$flg = 0;
			} else {
				$message_data[$j][$k] = ${$mlist_ref}[$i];
				$k ++;
			}
		}
	}
	
	$message_count = $j - 1;
	return 'true';
}


# bZ[W̏
sub message_initialize_rtn {
	@message_no = ();
	@message_id = ();
	@message_title = ();
	@message_time = ();
	@message_flg = ();
	@message_ip = ();
	@message_data = ();
	@message_length = ();
}


# zÕfR[h
sub letter_decode_rtn {
	local($llist_ref, $letter_file, $i, $j, $k, $flg);
	
	$letter_file = $_[0];
	
	$llist_ref = &file_read(LET, $letter_file, 0);
	if ($filerr) {	return 'false';	}
	
	chomp(@{$llist_ref});
	
	&letter_initialize_rtn;
	
	$j = 0;
	$flg = 0;
	for ($i = 0; $i <= $#{$llist_ref}; $i ++) {
		if ($flg == 0) {
			($letter_no[$j], $letter_name[$j], $letter_pass[$j], $letter_title[$j], $letter_time[$j], $letter_mail[$j], $letter_home[$j], $letter_ip[$j]) = split(/,/, ${$llist_ref}[$i]);
			$letter_name[$j] =~ s/&comma;/,/g;
			$letter_title[$j] =~ s/&comma;/,/g;
			$letter_mail[$j] =~ s/&comma;/,/g;
			$letter_home[$j] =~ s/&comma;/,/g;
			$flg = 1;
			$k = 0;
		} else {
			if (${$llist_ref}[$i] eq "<>") {
				if ($k == 0) {	$letter_length[$j] = 0;	}
				else {	$letter_length[$j] = $k - 1;	}
				$j ++;
				$flg = 0;
			} else {
				$letter_data[$j][$k] = ${$llist_ref}[$i];
				$k ++;
			}
		}
	}
	
	$letter_count = $j - 1;
	return 'true';
}


# z̏
sub letter_initialize_rtn {
	@letter_no = ();
	@letter_name = ();
	@letter_pass = ();
	@letter_title = ();
	@letter_time = ();
	@letter_mail = ();
	@letter_home = ();
	@letter_ip = ();
	@letter_data = ();
	@letter_length = ();
}


# Rg̃fR[h
sub comment_decode_rtn {
	local($clist_ref, $comment_file);
	
	$comment_file = $_[0];
	
	@comm_comment = ();
	
	$clist_ref = &file_read(COM, $comment_file, 0);
	if ($filerr) {	return 'false';	}
	@comm_comment = @{$clist_ref};
	
	chomp(@comm_comment);
	
	return 'true';
}


# ^ÕfR[h
sub tag_decode_rtn {
	local($tlist_ref, $tag_file, $i);
	
	$tag_file = $_[0];
	
	@tag_text = ();
	
	$tlist_ref = &file_read(TAG, $tag_file, 0);
	if ($filerr) {	return 'false';	}
	@tag_text = split(/ /, ${$tlist_ref}[0]);
	
	chomp(@tag_text);
	
	return 'true';
}


1;

__END__

