# ÑfR[h
sub link_decode_rtn {
	local($llist_ref, $i);
	
	$llist_ref = &file_read(LLT, $sslink_addr, 0);
	if ($filerr) {	return 'false';	}
	
	&link_initialize_rtn;
	
	chomp(@{$llist_ref});
	
	for ($i = 0; $i <= $#{$llist_ref}; $i ++) {
		($link_id[$i], $link_addr[$i], $link_path[$i], $link_env_no[$i], $link_url[$i], $link_name[$i], $link_desc[$i], $link_time[$i], $link_exec[$i], $link_err[$i]) = split(/,/, ${$llist_ref}[$i]);
		$link_addr[$i] =~ s/&comma;/,/g;
		$link_path[$i] =~ s/&comma;/,/g;
		$link_url[$i] =~ s/&comma;/,/g;
		$link_name[$i] =~ s/&comma;/,/g;
		$link_desc[$i] =~ s/&comma;/,/g;
		if ($link_exec[$i]) {	$link_exec_cnt ++;	}
		
		$LINK_POINT{$link_id[$i]} = $i;
		$LINK_POINT2{"$link_addr[$i]-$link_path[$i]-$link_env_no[$i]"} = $i;
	}
	
	$link_open = 1;
	
	return 'true';
}


# N̍폜
sub link_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#link_id) {	return &array_delete($_[0], 'link_id', 'link_addr', 'link_path', 'link_env_no', 'link_url', 'link_name', 'link_desc', 'link_time', 'link_exec', 'link_err');	}
	return 0;
}


# N̕ۑ
sub link_save_rtn {
	local($flist, $i, $cnt);
	
	if ($link_open) {
		%LINK_POINT = ();
		%LINK_POINT2 = ();
		$flist = '';
		$cnt = 0;
		for ($i = 0; $i <= $#link_id; $i ++) {
			$LINK_POINT{$link_id[$i]} = $i;
			$LINK_POINT2{"$link_addr[$i]-$link_path[$i]-$link_env_no[$i]"} = $i;
			
			$link_addr[$i] =~ s/,/&comma;/g;
			$link_path[$i] =~ s/,/&comma;/g;
			$link_url[$i] =~ s/,/&comma;/g;
			$link_name[$i] =~ s/,/&comma;/g;
			$link_desc[$i] =~ s/,/&comma;/g;
			if ($cnt >= $link_max) {	$link_exec[$i] = 0;	}
			elsif ($link_exec[$i]) {	$cnt ++;	}
			$flist .= "$link_id[$i],$link_addr[$i],$link_path[$i],$link_env_no[$i],$link_url[$i],$link_name[$i],$link_desc[$i],$link_time[$i],$link_exec[$i],$link_err[$i]\n";
			$link_addr[$i] =~ s/&comma;/,/g;
			$link_path[$i] =~ s/&comma;/,/g;
			$link_url[$i] =~ s/&comma;/,/g;
			$link_name[$i] =~ s/&comma;/,/g;
			$link_desc[$i] =~ s/&comma;/,/g;
		}
		
		if (&file_write(OUT, $sslink_addr, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# N̏
sub link_initialize_rtn {
	@link_id = ();
	@link_addr = ();
	@link_path = ();
	@link_env_no = ();
	@link_url = ();
	@link_name = ();
	@link_desc = ();
	@link_time = ();
	@link_exec = ();
	@link_err = ();
	%LINK_POINT = ();
	%LINK_POINT2 = ();
	$link_exec_cnt = 0;
}


# Nf[^̃fR[h
sub link_stock_decode_rtn {
	local($llist_ref, $i);
	
	$llist_ref = &file_read(LLT, $sslink_stock, 0);
	if ($filerr) {	return 'false';	}
	
	&link_stock_initialize_rtn;
	
	chomp(@{$llist_ref});
	
	for ($i = 0; $i <= $#{$llist_ref}; $i ++) {
		($link_stock_date[$i], $link_stock_id[$i], $link_stock_message[$i], $link_stock_link[$i]) = split(/,/, ${$llist_ref}[$i]);
		$link_stock_message[$i] =~ s/&comma;/,/g;
		
		$LINK_STOCK_POINT{"$link_stock_date[$i]-$link_stock_id[$i]"} = $i;
	}
	
	$link_stock_open = 1;
	
	return 'true';
}


# Nf[^̍폜
sub link_stock_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#link_stock_id) {	return &array_delete($_[0], 'link_stock_date', 'link_stock_id', 'link_stock_message');	}
	return 0;
}


# Nf[^̕ۑ
sub link_stock_save_rtn {
	local($flist, $i);
	
	if ($link_stock_open) {
		%LINK_STOCK_POINT = ();
		$flist = '';
		for ($i = 0; $i <= $#link_stock_date; $i ++) {
			$LINK_STOCK_POINT{"$link_stock_date[$i]-$link_stock_id[$i]"} = $i;
			
			$link_stock_message[$i] =~ s/,/&comma;/g;
			$flist .= "$link_stock_date[$i],$link_stock_id[$i],$link_stock_message[$i],$link_stock_link[$i]\n";
			$link_stock_message[$i] =~ s/&comma;/,/g;
		}
		
		if (&file_write(OUT, $sslink_stock, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# Nf[^̏
sub link_stock_initialize_rtn {
	@link_stock_date = ();
	@link_stock_id = ();
	@link_stock_message = ();
	@link_stock_link = ();
	%LINK_STOCK_POINT = ();
}


1;

__END__

