# ZbVID̃fR[h
sub sessionid_decode_rtn {
	local($slist_ref, $i);
	
	$slist_ref = &file_read(SESS, $sessionid, 0);
	if ($filerr) {	return 'false';	}
	
	&sessionid_initialize_rtn;
	
	chomp(@{$slist_ref});
	
	for ($i = 0; $i <= $#{$slist_ref}; $i ++) {
		($sessionid_id[$i], $sessionid_author[$i], $sessionid_time[$i], $sessionid_reserve[$i], $sessionid_ip[$i], $sessionid_type[$i]) = split(/,/, ${$slist_ref}[$i]);
		
		$SESSIONID_POINT{$sessionid_id[$i]} = $i;
	}
	
	$sessionid_open = 1;
	
	return 'true';
}


# ZbVID̍폜
sub sessionid_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#sessionid_id) {	return &array_delete($_[0], 'sessionid_id', 'sessionid_author', 'sessionid_time', 'sessionid_reserve', 'sessionid_type');	}
	return 0;
}


# ZbVID̕ۑ
sub sessionid_save_rtn {
	local($flist, $i);
	
	if ($sessionid_open) {
		%SESSIONTID_POINT = ();
		$flist = '';
		$i = 0;
		while ($i <= $#sessionid_id) {
			if ((!$sessionid_reserve[$i] && time() - $sessionid_time[$i] >= $sessionid_timeout) || (time() - $sessionid_time[$i] >= $cookie_expires * 86400)) {	&sessionid_delete_rtn($i);	}
			else {
				$SESSIONID_POINT{$sessionid_id[$i]} = $i;
				$flist .= "$sessionid_id[$i],$sessionid_author[$i],$sessionid_time[$i],$sessionid_reserve[$i],$sessionid_ip[$i],$sessionid_type[$i]\n";
				$i ++;
			}
		}
		
		if (&file_write(OUT, $sessionid, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# ZbVID̏
sub sessionid_initialize_rtn {
	@sessionid_id = ();
	@sessionid_author = ();
	@sessionid_time = ();
	@sessionid_reserve = ();
	@sessionid_ip = ();
	@sessionid_type = ();
	%SESSIONID_POINT = ();
}


1;

__END__

