# fރXg\
sub sozai_list_rtn {
	local($cn, $ps, $rs, $query, $i, $flist, $image_session_use, $sound_session_use, $movie_session_use);
	
	&u_header($A_KNAME{$author_id[$author_number]});
	
	if (!$dbmode) {
		if (!$image_open) {
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {
				$image_session_use = 0;
				$flist = &session_read("$env_no-imagelist-$id.dat", $imglist);
				if ($flist) {
					$image_session_use = 1;
					&image_decode($flist);
					$image_open = 0;
				} else {	&image_decode;	}
			} else {
				$image_session_use = 1;
				&image_decode;
			}
		}
		if (!$sound_open) {
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {
				$sound_session_use = 0;
				$flist = &session_read("$env_no-soundlist-$id.dat", $soundlist);
				if ($flist) {
					$sound_session_use = 1;
					&sound_decode($flist);
					$sound_open = 0;
				} else {	&sound_decode;	}
			} else {
				$sound_session_use = 1;
				&sound_decode;
			}
		}
		if (!$movie_open) {
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {
				$movie_session_use = 0;
				$flist = &session_read("$env_no-movielist-$id.dat", $movielist);
				if ($flist) {
					$movie_session_use = 1;
					&movie_decode($flist);
					$movie_open = 0;
				} else {	&movie_decode;	}
			} else {
				$movie_session_use = 1;
				&movie_decode;
			}
		}
	} else {
		$cn = &get_connection;
		
		&image_initialize;
		&sound_initialize;
		&movie_initialize;
		eval {
			$query = <<EOM;
SELECT
  IMAGE_ID,
  IMAGE_NAME,
  IMAGE_TAIL,
  IMAGE_DESCRIPTION,
  IMAGE_STATE,
  IMAGE_UPPER,
  IMAGE_WIDTH,
  IMAGE_HEIGHT,
  IMAGE_FNAME
FROM [#name#]_IMAGE
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE IMAGE_UPPER = ?\n";	}
			$query .= 'ORDER BY IMAGE_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@image_id, ${$rs}[0]);
				push(@image_name, ${$rs}[1]);
				push(@image_tail, ${$rs}[2]);
				push(@image_description, ${$rs}[3]);
				push(@image_state, ${$rs}[4]);
				push(@image_upper, ${$rs}[5]);
				push(@image_width, ${$rs}[6]);
				push(@image_height, ${$rs}[7]);
				push(@image_fname, ${$rs}[8]);
				$IMAGE_POINT{$image_id[$#image_id]} = $#image_id;
			}
			$ps->finish;
			$query = <<EOM;
SELECT
  SOUND_ID,
  SOUND_NAME,
  SOUND_TAIL,
  SOUND_DESCRIPTION,
  SOUND_STATE,
  SOUND_UPPER,
  SOUND_FNAME
FROM [#name#]_SOUND
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE SOUND_UPPER = ?\n";	}
			$query .= 'ORDER BY SOUND_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@sound_id, ${$rs}[0]);
				push(@sound_name, ${$rs}[1]);
				push(@sound_tail, ${$rs}[2]);
				push(@sound_description, ${$rs}[3]);
				push(@sound_state, ${$rs}[4]);
				push(@sound_upper, ${$rs}[5]);
				push(@sound_fname, ${$rs}[6]);
				$SOUND_POINT{$sound_id[$#sound_id]} = $#sound_id;
			}
			$ps->finish;
			$query = <<EOM;
SELECT
  MOVIE_ID,
  MOVIE_NAME,
  MOVIE_TAIL,
  MOVIE_DESCRIPTION,
  MOVIE_STATE,
  MOVIE_UPPER,
  MOVIE_WIDTH,
  MOVIE_HEIGHT,
  MOVIE_FNAME
FROM [#name#]_MOVIE
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE MOVIE_UPPER = ?\n";	}
			$query .= 'ORDER BY MOVIE_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@movie_id, ${$rs}[0]);
				push(@movie_name, ${$rs}[1]);
				push(@movie_tail, ${$rs}[2]);
				push(@movie_description, ${$rs}[3]);
				push(@movie_state, ${$rs}[4]);
				push(@movie_upper, ${$rs}[5]);
				push(@movie_width, ${$rs}[6]);
				push(@movie_height, ${$rs}[7]);
				push(@movie_fname, ${$rs}[8]);
				$MOVIE_POINT{$movie_id[$#movie_id]} = $#movie_id;
			}
			$ps->finish;
			if ($author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
				&author_initialize;
				$query = <<EOM;
SELECT
  AUTHOR_ID,
  AUTHOR_PASS,
  AUTHOR_NAME,
  AUTHOR_STATE,
  AUTHOR_MAIL,
  AUTHOR_HOME,
  AUTHOR_COMMENT,
  AUTHOR_BG,
  AUTHOR_BGCOLOR,
  AUTHOR_TEXT
FROM [#name#]_AUTHOR
ORDER BY AUTHOR_DATE
EOM
				$query =~ s/\[#name#\]/$dbheader/g;
				$ps = $cn->prepare($query);
				$ps->execute;
				while ($rs = $ps->fetch) {
					push(@author_id, ${$rs}[0]);
					push(@author_pass, ${$rs}[1]);
					push(@author_name, ${$rs}[2]);
					push(@author_state, ${$rs}[3]);
					push(@author_mail, ${$rs}[4]);
					push(@author_home, ${$rs}[5]);
					push(@author_comment, ${$rs}[6]);
					push(@author_bg, ${$rs}[7]);
					push(@author_bgcolor, ${$rs}[8]);
					push(@author_text, ${$rs}[9]);
					$AUTHOR_POINT{$author_id[$#author_id]} = $#author_id;
					if ($author_id[$#author_id] eq $id) {	$author_number = $#author_id;	}
				}
				$ps->finish;
			}
		};
	}
	
	print <<EOM;
<center>
<h1>폜fނIĂ</h1>
<br>
<form name="sozai_del" action="$uploader" method="post">
<input type="hidden" name="mode" value="sozai_del">
$id_str
<table border="1" width="750">
<tr>
<td align="center">폜</td>
<td align="center">No</td>
<td align="center">fޖ</td>
<td align="center">fޏڍ</td>
<td align="center">L</td>
EOM
	if ($author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
		print <<EOM;
<td align="center" align="center">Abv[h</td>
EOM
	}
	print <<EOM;
</tr>
<tr>
<td colspan="6" align="center"><b>摜</b></td>
</tr>
EOM
	$flist = '';
	for ($i = 0; $i <= $#image_id; $i ++) {
		if ($image_upper[$i] eq $id || $author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
			$flist .= "$image_idx[$i]\n";
			if (!$image_fname[$i]) {	$image_fname[$i] = "$image_id[$i].$image_tail[$i]";	}
			$image_fname[$i] = &url_encode($image_fname[$i]);
			print <<EOM;
<tr>
<td align="center"><input type="checkbox" name="image-$image_id[$i]"></td>
<td align="center">$image_id[$i]</td>
<td align="center">$image_name[$i]</td>
<td align="left">$image_description[$i]<br><a href="$image/$image_fname[$i]" target="_blank">$image/$image_fname[$i]</a></td>
EOM
			if ($image_state[$i]) {
				print <<EOM;
<td align="center">L</td>
EOM
			} else {
				print <<EOM;
<td align="center">l</td>
EOM
			}
			if ($author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
				print <<EOM;
<td align="center"><b>$author_name[$AUTHOR_POINT{$image_upper[$i]}]</b></td>
EOM
			}
			print <<EOM;
</tr>
EOM
		}
	}
	if (!$dbmode) {
		if (!$image_session_use) {	&session_save("$env_no-imagelist-$id.dat", \$flist);	}
	}
	print <<EOM;
<tr>
<td colspan="6" align="center"><b>y</b></td>
</tr>
EOM
	$flist = '';
	for ($i = 0; $i <= $#sound_id; $i ++) {
		if ($sound_upper[$i] eq $id || $author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
			$flist .= "$sound_idx[$i]\n";
			if (!$sound_fname[$i]) {	$sound_fname[$i] = "$sound_id[$i].$sound_tail[$i]";	}
			$sound_fname[$i] = &url_encode($sound_fname[$i]);
			print <<EOM;
<tr>
<td align="center"><input type="checkbox" name="sound-$sound_id[$i]"></td>
<td align="center">$sound_id[$i]</td>
<td align="center">$sound_name[$i]</td>
<td align="left">$sound_description[$i]<br><a href="$sound/$sound_fname[$i]" target="_blank">$sound/$sound_fname[$i]</a></td>
EOM
			if ($sound_state[$i]) {
				print <<EOM;
<td align="center">L</td>
EOM
			} else {
				print <<EOM;
<td align="center">l</td>
EOM
			}
			if ($author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
				print <<EOM;
<td align="center"><b>$author_name[$AUTHOR_POINT{$sound_upper[$i]}]</b></td>
EOM
			}
			print <<EOM;
</tr>
EOM
		}
	}
	if (!$dbmode) {
		if (!$sound_session_use) {	&session_save("$env_no-soundlist-$id.dat", \$flist);	}
	}
	print <<EOM;
<tr>
<td colspan="6" align="center"><b></b></td>
</tr>
EOM
	$flist = '';
	for ($i = 0; $i <= $#movie_id; $i ++) {
		if ($movie_upper[$i] eq $id || $author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
			$flist .= "$movie_idx[$i]\n";
			if (!$movie_fname[$i]) {	$movie_fname[$i] = "$movie_id[$i].$movie_tail[$i]";	}
			$movie_fname[$i] = &url_encode($movie_fname[$i]);
			print <<EOM;
<tr>
<td align="center"><input type="checkbox" name="movie-$movie_id[$i]"></td>
<td align="center">$movie_id[$i]</td>
<td align="center">$movie_name[$i]</td>
<td align="left">$movie_description[$i]<br><a href="$movie/$movie_fname[$i]" target="_blank">$movie/$movie_fname[$i]</a></td>
EOM
			if ($movie_state[$i]) {
				print <<EOM;
<td align="center">L</td>
EOM
			} else {
				print <<EOM;
<td align="center">l</td>
EOM
			}
			if ($author_state[$author_number] == 2 || $author_state[$author_number] == -2) {
				print <<EOM;
<td align="center"><b>$author_name[$AUTHOR_POINT{$sound_upper[$i]}]</b></td>
EOM
			}
			print <<EOM;
</tr>
EOM
		}
	}
	if (!$dbmode) {
		if (!$movie_session_use) {	&session_save("$env_no-movielist-$id.dat", \$flist);	}
	}
	print <<EOM;
</table>
<br>
<input type="submit" value="Ifނ폜" onClick="return confirm('Ifނ폜܂B낵łH');">
</form>
</center>
<br>
<hr>
<br>
EOM
	&menu;
	
	&u_footer;
	
	&exit;
}


# fލ폜
sub sozai_del_rtn {
	local($cn, $ps, $rs, $query, @image_dellist, @sound_dellist, @movie_dellist, @image_flist, @sound_flist, @movie_flist, $i);
	
	# 폜ID̎擾
	if (!$dbmode) {	&image_decode;	}
	else {
		$cn = &get_connection;
		
		&image_initialize;
		eval {
			$query = <<EOM;
SELECT
  IMAGE_ID,
  IMAGE_NAME,
  IMAGE_TAIL,
  IMAGE_DESCRIPTION,
  IMAGE_STATE,
  IMAGE_UPPER,
  IMAGE_WIDTH,
  IMAGE_HEIGHT,
  IMAGE_FNAME
FROM [#name#]_IMAGE
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE IMAGE_UPPER = ?\n";	}
			$query .= 'ORDER BY IMAGE_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@image_id, ${$rs}[0]);
				push(@image_name, ${$rs}[1]);
				push(@image_tail, ${$rs}[2]);
				push(@image_description, ${$rs}[3]);
				push(@image_state, ${$rs}[4]);
				push(@image_upper, ${$rs}[5]);
				push(@image_width, ${$rs}[6]);
				push(@image_height, ${$rs}[7]);
				push(@image_fname, ${$rs}[8]);
				$IMAGE_POINT{$image_id[$#image_id]} = $#image_id;
			}
			$ps->finish;
		};
	}
	@image_dellist = ();
	for ($i = 0; $i <= $#image_id; $i ++) {
		if ($FORM{"image-$image_id[$i]"}) {	push(@image_dellist, $i);	}
	}
	if (!$dbmode) {	&sound_decode;	}
	else {
		&sound_initialize;
		eval {
			$query = <<EOM;
SELECT
  SOUND_ID,
  SOUND_NAME,
  SOUND_TAIL,
  SOUND_DESCRIPTION,
  SOUND_STATE,
  SOUND_UPPER,
  SOUND_FNAME
FROM [#name#]_SOUND
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE SOUND_UPPER = ?\n";	}
			$query .= 'ORDER BY SOUND_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@sound_id, ${$rs}[0]);
				push(@sound_name, ${$rs}[1]);
				push(@sound_tail, ${$rs}[2]);
				push(@sound_description, ${$rs}[3]);
				push(@sound_state, ${$rs}[4]);
				push(@sound_upper, ${$rs}[5]);
				push(@sound_fname, ${$rs}[6]);
				$SOUND_POINT{$sound_id[$#sound_id]} = $#sound_id;
			}
			$ps->finish;
		};
	}
	@sound_dellist = ();
	for ($i = 0; $i <= $#sound_id; $i ++) {
		if ($FORM{"sound-$sound_id[$i]"}) {	push(@sound_dellist, $i);	}
	}
	if (!$dbmode) {	&movie_decode;	}
	else {
		&movie_initialize;
		eval {
			$query = <<EOM;
SELECT
  MOVIE_ID,
  MOVIE_NAME,
  MOVIE_TAIL,
  MOVIE_DESCRIPTION,
  MOVIE_STATE,
  MOVIE_UPPER,
  MOVIE_WIDTH,
  MOVIE_HEIGHT,
  MOVIE_FNAME
FROM [#name#]_MOVIE
EOM
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$query .= "WHERE MOVIE_UPPER = ?\n";	}
			$query .= 'ORDER BY MOVIE_ID';
			$query =~ s/\[#name#\]/$dbheader/g;
			$ps = $cn->prepare($query);
			if ($author_state[$author_number] != 2 && $author_state[$author_number] != -2) {	$ps->bind_param(1, $id);	}
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@movie_id, ${$rs}[0]);
				push(@movie_name, ${$rs}[1]);
				push(@movie_tail, ${$rs}[2]);
				push(@movie_description, ${$rs}[3]);
				push(@movie_state, ${$rs}[4]);
				push(@movie_upper, ${$rs}[5]);
				push(@movie_width, ${$rs}[6]);
				push(@movie_height, ${$rs}[7]);
				push(@movie_fname, ${$rs}[8]);
				$MOVIE_POINT{$movie_id[$#movie_id]} = $#movie_id;
			}
			$ps->finish;
		};
	}
	@movie_dellist = ();
	for ($i = 0; $i <= $#movie_id; $i ++) {
		if ($FORM{"movie-$movie_id[$i]"}) {	push(@movie_dellist, $i);	}
	}
	
	# 폜f[^ȂΏf
	if ($#image_dellist < 0 && $#sound_dellist < 0 && $#movie_dellist < 0) {
		&u_header($A_KNAME{$author_id[$author_number]});
		print <<EOM;
<center>
<h1><font color="$link">II폜fނIĂ܂II</font></h1>
<br>
<form name="back" action="$uploader" method="post">
<input type="hidden" name="mode" value="main">
$id_str
<input type="submit" value="߂">
</form>
</center>
<br>
<hr>
<br>
EOM
		&menu;
		&u_footer;
		&exit;
	}
	
	# 폜̎s
	eval {
		if ($#image_dellist >= 0) {
			@image_flist = ();
			if ($dbmode) {
				$query = 'DELETE FROM [#name#]_IMAGE WHERE IMAGE_ID = ?';
				$query =~ s/\[#name#\]/$dbheader/g;
				$ps = $cn->prepare($query);
			}
			for ($i = $#image_dellist; $i >= 0; $i --) {
				if ($image_fname[$image_dellist[$i]]) {	push(@image_flist, $image_fname[$image_dellist[$i]]);	}
				else {	push(@image_flist, "$image_id[$image_dellist[$i]].$image_tail[$image_dellist[$i]]");	}
				
				if ($dbmode) {	$ps->execute($image_id[$image_dellist[$i]]);	}
				&image_delete($image_dellist[$i]);
			}
			if (!$dbmode) {
				if (&image_save eq 'true') {
					for ($i = 0; $i <= $#image_flist; $i ++) {	unlink("$image/$image_flist[$i]");	}
				}
			} else {
				for ($i = 0; $i <= $#image_flist; $i ++) {	unlink("$image/$image_flist[$i]");	}
			}
		}
		if ($#sound_dellist >= 0) {
			@sound_flist = ();
			if ($dbmode) {
				$query = 'DELETE FROM [#name#]_SOUND WHERE SOUND_ID = ?';
				$query =~ s/\[#name#\]/$dbheader/g;
				$ps = $cn->prepare($query);
			}
			for ($i = $#sound_dellist; $i >= 0; $i --) {
				if ($sound_fname[$sound_dellist[$i]]) {	push(@sound_flist, $sound_fname[$sound_dellist[$i]]);	}
				else {	push(@sound_flist, "$sound_id[$sound_dellist[$i]].$sound_tail[$sound_dellist[$i]]");	}
				
				if ($dbmode) {	$ps->execute($sound_id[$sound_dellist[$i]]);	}
				&sound_delete($sound_dellist[$i]);
			}
			if (!$dbmode) {
				if (&sound_save eq 'true') {
					for ($i = 0; $i <= $#sound_flist; $i ++) {	unlink("$sound/$sound_flist[$i]");	}
				}
			} else {
				for ($i = 0; $i <= $#sound_flist; $i ++) {	unlink("$sound/$sound_flist[$i]");	}
			}
		}
		if ($#movie_dellist >= 0) {
			@movie_flist = ();
			if ($dbmode) {
				$query = 'DELETE FROM [#name#]_MOVIE WHERE MOVIE_ID = ?';
				$query =~ s/\[#name#\]/$dbheader/g;
				$ps = $cn->prepare($query);
			}
			for ($i = $#movie_dellist; $i >= 0; $i --) {
				if ($movie_fname[$movie_dellist[$i]]) {	push(@movie_flist, $movie_fname[$movie_dellist[$i]]);	}
				else {	push(@movie_flist, "$movie_id[$movie_dellist[$i]].$movie_tail[$movie_dellist[$i]]");	}
				
				if ($dbmode) {	$ps->execute($movie_id[$movie_dellist[$i]]);	}
				&movie_delete($movie_dellist[$i]);
			}
			if (!$dbmode) {
				if (&movie_save eq 'true') {
					for ($i = 0; $i <= $#movie_flist; $i ++) {	unlink("$movie/$movie_flist[$i]");	}
				}
			} else {
				for ($i = 0; $i <= $#movie_flist; $i ++) {	unlink("$movie/$movie_flist[$i]");	}
			}
		}
		if ($dbmode) {	$cn->do('COMMIT');	}
	};
	if ($dbmode && $@) {	$cn->do('ROLLBACK');	}
	
	&u_header($A_KNAME{$author_id[$author_number]});
	
	print <<EOM;
<center>
<h1>Ifނ폜܂</h1>
<br>
<form name="back" action="$uploader" method="post">
<input type="hidden" name="mode" value="main">
$id_str
<input type="submit" value="߂">
</form>
</center>
<br>
<hr>
<br>
EOM
	&menu;
	
	&u_footer;
	
	&exit;
}


1;

__END__

