# 2009/09/04ǉ
# Base64GR[h
sub base64_encode_rtn {
	local($raw_str_ref, $mime_flg, @base_table, $len, $group, $base_encode, @chord, @str);
	
	@base_table = ('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 
			'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 
			'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 
			'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 
			'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/');
	
	if (ref($_[0]) =~ /SCALAR/i) {	$raw_str_ref = $_[0];	}
	else {	$raw_str_ref = \$_[0];	}
	$mime_flg = $_[1];
	
	$len = length(${$raw_str_ref});
	$group = int($len / 3);
	
	$base_encode = '';
	for ($i = 0; $i < $group; $i ++) {
		$chord[0] = ord(substr(${$raw_str_ref}, $i * 3, 1)) & 0xff;
		$chord[1] = ord(substr(${$raw_str_ref}, $i * 3 + 1, 1)) & 0xff;
		$chord[2] = ord(substr(${$raw_str_ref}, $i * 3 + 2, 1)) & 0xff;
		
		$str[0] = $base_table[($chord[0] >> 2)];
		$str[1] = $base_table[($chord[0] << 4) & 0x3f | ($chord[1] >> 4)];
		$str[2] = $base_table[($chord[1] << 2) & 0x3f | ($chord[2] >> 6)];
		$str[3] = $base_table[($chord[2]) & 0x3f];
		
		$base_encode .= $str[0] . $str[1] . $str[2] . $str[3];
		
		if ($mime_flg && (length($base_encode) + 1) % 77 == 0) {	$base_encode .= "\n";	}
	}
	
	@str = ();
	if ($len - ($group * 3) > 0) {
		$str[4] = substr(${$raw_str_ref}, $group * 3, $len - ($group * 3));
		
		$chord[0] = ord(substr($str[4], 0, 1)) & 0xff;
		$str[0] = $base_table[($chord[0] >> 2)];
		if ($len - ($group * 3) == 1) {
			$str[1] = $base_table[($chord[0] << 4) & 0x3f];
			$str[2] = '=';
			$str[3] = '=';
		} else {
			$chord[1] = ord(substr($str[4], 1, 1)) & 0xff;
			$str[1] = $base_table[($chord[0] << 4) & 0x3f |  ($chord[1] >> 4)];
			$str[2] = $base_table[($chord[1] << 2) & 0x3f];
			$str[3] = '=';
		}
		
		$base_encode .= $str[0] . $str[1] . $str[2] . $str[3];
	}
	
	if ($mime_flg && (length($base_encode) + 1) % 77 == 0) {	$base_encode .= "\n";	}
	
	return \$base_encode;
}


# 2009/09/04ǉ
# Base64fR[h
sub base64_decode_rtn {
	local($raw_str_ref, $mime_flg, $len, $group, @base_table, $base_decode, @chord, @str, $i);
	
	@base_table = (-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
			-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
			-1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54,
			55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4,
			5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
			24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34,
			35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51);
	
	if (ref($_[0]) =~ /SCALAR/i) {	$raw_str_ref = $_[0];	}
	else {	$raw_str_ref = \$_[0];	}
	$mime_flg = $_[1];
	if ($mime_flg == 1) {	${$raw_str_ref} =~ s/(\r)?(\n)//g;	}
	$len = length(${$raw_str_ref});
	$group = int($len / 4);
	
	if ($len % 4 != 0) {	return -1;	}
	
	@base_decode = ();
	for ($i = 0; $i < $group - 1; $i ++) {
		$chord[0] = @base_table[ord(substr(${$raw_str_ref}, $i * 4, 1))];
		$chord[1] = @base_table[ord(substr(${$raw_str_ref}, $i * 4 + 1, 1))];
		$chord[2] = @base_table[ord(substr(${$raw_str_ref}, $i * 4 + 2, 1))];
		$chord[3] = @base_table[ord(substr(${$raw_str_ref}, $i * 4 + 3, 1))];
		
		if ($chord[0] >= 0 && $chord[1] >= 0 && $chord[2] >= 0 && $chord[3] >= 0) {
			$str[0] = pack("c", ($chord[0] << 2) | ($chord[1] >> 4));
			$str[1] = pack("c", ($chord[1] << 4) | ($chord[2] >> 2));
			$str[2] = pack("c", ($chord[2] << 6) | ($chord[3]));
			
			$base_decode .= $str[0] . $str[1] . $str[2];
		} else {	return -1;	}
	}
	
	@str = ();
	$str[3] = substr(${$raw_str_ref}, ($group - 1) * 4, 4);
	
	$chord[0] = @base_table[ord(substr($str[3], 0, 1))];
	$chord[1] = @base_table[ord(substr($str[3], 1, 1))];
	if (substr($str[3], 2, 1) eq '=') {
		$str[0] = pack("c", ($chord[0] << 2) | ($chord[1] >> 4));
		if ($chord[1] & 0x0f) {	$str[1] = pack("c", ($chord[1] << 4));	}
		else {	$str[1] = '';	}
		$str[2] = '';
	} else {
		$chord[2] = @base_table[ord(substr($str[3], 2, 1))];
		if (substr($str[3], 3, 1) eq '=') {
			$str[0] = pack("c", ($chord[0] << 2) | ($chord[1] >> 4));
			$str[1] = pack("c", ($chord[1] << 4) | ($chord[2] >> 2));
			if ($chord[2] & 0x03) {	$str[2] = pack("c", ($chord[2] << 6));	}
			else {	$str[2] = '';	}
		} else {
			$chord[3] = @base_table[ord(substr($str[3], 3, 1))];
			$str[0] = pack("c", ($chord[0] << 2) | ($chord[1] >> 4));
			$str[1] = pack("c", ($chord[1] << 4) | ($chord[2] >> 2));
			$str[2] = pack("c", ($chord[2] << 6) | ($chord[3]));
		}
	}
	
	if ($chord[0] >= 0 && $chord[1] >= 0 && $chord[2] >= 0 && $chord[3] >= 0) {
		$base_decode .= $str[0] . $str[1] . $str[2];
		return \$base_decode;
	} else {
		return -1;
	}
}


1;

__END__

