# yXgf[^̃fR[h
sub sound_decode_rtn {
	local($selist_ref, $i, $idx);
	
	if ($_[0]) {
		if (ref($_[0]) =~ /ARRAY/i) {	$selist_ref = &file_read(SOUND, $soundlist, 0, $_[0]);	}
		else {	$selist_ref = &file_read(SOUND, $soundlist, 0);	}
	} else {	$selist_ref = &file_read(SOUND, $soundlist, 0);	}
	if ($filerr) {	return 'false'	}
	
	&sound_initialize_rtn;
	$idx = 0;
	
	for ($i = 0; $i <= $#{$selist_ref}; $i ++) {
		$sound_idx[$i] = $idx;
		$idx += length(${$selist_ref}[$i]);
		chomp(${$selist_ref}[$i]);
		($sound_id[$i], $sound_name[$i], $sound_tail[$i], $sound_description[$i], $sound_state[$i], $sound_upper[$i], $sound_fname[$i]) = split(/,/, ${$selist_ref}[$i]);
		$sound_name[$i] =~ s/&comma;/,/g;
		$sound_description[$i] =~ s/&comma;/,/g;
		$sound_fname[$i] =~ s/&comma;/,/g;
		
		$SOUND_POINT{$sound_id[$i]} = $i;
	}
	
	$sound_open = 1;
	
	return 'true';
}


# yXgf[^̍폜
sub sound_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#sound_id) {	return &array_delete($_[0], 'sound_id', 'sound_name', 'sound_tail', 'sound_description', 'sound_state', 'sound_upper', 'sound_fname');	}
	return 0;
}


# yXgf[^̕ۑ
sub sound_save_rtn {
	local($flist, $i);
	
	if ($sound_open) {
		%SOUND_POINT = ();
		$flist = '';
		for ($i = 0; $i <= $#sound_id; $i ++) {
			$sound_idx[$i] = length($flist);
			$SOUND_POINT{$sound_id[$i]} = $i;
			
			$sound_name[$i] =~ s/,/&comma;/g;
			$sound_description[$i] =~ s/,/&comma;/g;
			$sound_fname[$i] =~ s/,/&comma;/g;
			$flist .= "$sound_id[$i],$sound_name[$i],$sound_tail[$i],$sound_description[$i],$sound_state[$i],$sound_upper[$i],$sound_fname[$i]\n";
			$sound_name[$i] =~ s/&comma;/,/g;
			$sound_description[$i] =~ s/&comma;/,/g;
			$sound_fname[$i] =~ s/&comma;/,/g;
		}
		
		if (&file_write(OUT, $soundlist, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# yXg̏
sub sound_initialize_rtn {
	@sound_id = ();
	@sound_name = ();
	@sound_tail = ();
	@sound_description = ();
	@sound_state = ();
	@sound_upper = ();
	@sound_fname = ();
	%SOUND_POINT = ();
	@sound_idx = ();
}


1;

__END__

