# rrXgf[^̃fR[h
sub sslist_decode_rtn {
	local($ss_list_ref, $i, $idx);
	
	if ($_[0]) {
		if (ref($_[0]) =~ /ARRAY/i) {	$ss_list_ref = &file_read(SS, $sslist, 0, $_[0]);	}
		else {	$ss_list_ref = &file_read(SS, $sslist, 0);	}
	} else {	$ss_list_ref = &file_read(SS, $sslist, 0);	}
	if ($filerr) {	return 'false';	}
	
	&sslist_initialize_rtn;
	$idx = 0;
	
	for ($i = 0; $i <= $#{$ss_list_ref}; $i ++) {
		$ss_idx[$i] = $idx;
		$idx += length(${$ss_list_ref}[$i]);
		chomp(${$ss_list_ref}[$i]);
		($ss_author[$i], $ss_no[$i], $ss_title[$i], $ss_description[$i], $ss_state[$i], $ss_showed[$i], $ss_comments[$i], $ss_letters[$i], $ss_cate[$i], $ss_page2[$i], $ss_date[$i], $ss_timv[$i], $ss_taglock[$i], $ss_update[$i], $ss_valuate[$i], $ss_type[$i]) = split(/,/, ${$ss_list_ref}[$i]);
		$ss_title[$i] =~ s/&comma;/,/g;
		$ss_description[$i] =~ s/&comma;/,/g;
		
		$SS_POINT{$ss_no[$i]} = $i;
	}
	
	$sslist_open = 1;
	
	return 'true';
}


# rrXgf[^̍폜
sub sslist_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#ss_no) {	return &array_delete($_[0], 'ss_author', 'ss_no', 'ss_title', 'ss_description', 'ss_state', 'ss_showed', 'ss_comments', 'ss_letters', 'ss_cate', 'ss_page2', 'ss_date', 'ss_timv', 'ss_taglock', 'ss_update', 'ss_valuate', 'ss_type');	}
	return 0;
}


# rrXgf[^̕ۑ
sub sslist_save_rtn {
	local($flist, $i);
	
	if ($sslist_open) {
		%SS_POINT = ();
		$flist = '';
		for ($i = 0; $i <= $#ss_author; $i ++) {
			$ss_idx[$i] = length($flist);
			$SS_POINT{$ss_no[$i]} = $i;
			
			$ss_title[$i] =~ s/,/&comma;/g;
			$ss_description[$i] =~ s/,/&comma;/g;
			$flist .= "$ss_author[$i],$ss_no[$i],$ss_title[$i],$ss_description[$i],$ss_state[$i],$ss_showed[$i],$ss_comments[$i],$ss_letters[$i],$ss_cate[$i],$ss_page2[$i],$ss_date[$i],$ss_timv[$i],$ss_taglock[$i],$ss_update[$i],$ss_valuate[$i],$ss_type[$i]\n";
			$ss_title[$i] =~ s/&comma;/,/g;
			$ss_description[$i] =~ s/&comma;/,/g;
		}
		
		if (&file_write(OUT, $sslist, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# rrXg
sub sslist_initialize_rtn {
	@ss_author = ();
	@ss_no = ();
	@ss_title = ();
	@ss_description = ();
	@ss_state = ();
	@ss_showed = ();
	@ss_comments = ();
	@ss_letters = ();
	@ss_cate = ();
	@ss_page2 = ();
	@ss_date = ();
	@ss_timv = ();
	@ss_taglock = ();
	@ss_update = ();
	@ss_valuate = ();
	@ss_type = ();
	%SS_POINT = ();
	@ss_idx = ();
}


# 2009/10/23ǉ
# rrԃXgf[^̃fR[h
sub ss_flow_decode_rtn {
	local($slist_ref, $i);
	
	$slist_ref = &file_read(SS, $ss_flow, 0);
	if ($filerr) {	return 'false';	}
	
	@ss_flow_no = ();
	
	chomp(@{$slist_ref});
	for ($i = 0; $i <= $#{$slist_ref}; $i ++) {	$ss_flow_no[$i] = ${$slist_ref}[$i];	}
	
	$ss_flow_open = 1;
	
	return 'true';
}


# rrԃXgf[^̕ۑ
sub ss_flow_save_rtn {
	local($flist, $i);
	
	if ($ss_flow_open) {
		$flist = '';
		for ($i = 0; $i <= $#ss_flow_no; $i ++) {	$flist .= "$ss_flow_no[$i]\n";	}
		
		if (&file_write(OUT, $ss_flow, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


1;

__END__

