# W̃fR[h
sub sstype_decode_rtn {
	local($tlist_ref, $i);
	
	$tlist_ref = &file_read(TYP, $sstypelist, 0);
	if ($filerr) {	return 'false';	}
	
	chomp(@{$tlist_ref});
	
	&sstype_initialize_rtn;
	
	for ($i = 0; $i <= $#{$tlist_ref}; $i ++) {
		($sstype_no[$i], $sstype_name[$i], $sstype_descript[$i]) = split(/,/, ${$tlist_ref}[$i]);
		$sstype_name[$i] =~ s/&comma;/,/g;
		$sstype_descript[$i] =~ s/&comma;/,/g;
		
		$SSTYPE_POINT{$sstype_no[$i]} = $i;
	}
	
	$sstype_open = 1;
	
	return 'true';
}


# W̍폜
sub sstype_delete_rtn {
	if ($_[0] =~ /^[0-9]+$/ && $_[0] >= 0 && $_[0] <= $#sstype_no) {	return &array_delete($_[0], 'sstype_no', 'sstype_name', 'sstype_description');	}
	return 0;
}


# W̕ۑ
sub sstype_save_rtn {
	local($flist, $i);
	
	if ($sstype_open) {
		%SSTYPE_POINT = ();
		$flist = '';
		for ($i = 0; $i <= $#sstype_no; $i ++) {
			$SSTYPE_POINT{$sstype_no[$i]} = $i;
			
			$sstype_name[$i] =~ s/,/&comma;/g;
			$sstype_descript[$i] =~ s/,/&comma;/g;
			$flist .= "$sstype_no[$i],$sstype_name[$i],$sstype_descript[$i]\n";
			$sstype_name[$i] =~ s/&comma;/,/g;
			$sstype_descript[$i] =~ s/&comma;/,/g;
		}
		
		if (&file_write(OUT, $sstypelist, \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {	return 'false';	}
}


# W̏
sub sstype_initialize_rtn {
	@sstype_no = ();
	@sstype_name = ();
	@sstype_descript = ();
	%SSTYPE_POINT = ();
}


1;

__END__

