# PNGTCY擾
sub png_size_get_rtn {
	local(@yoko, @tate, $flist_ref);
	
	if (ref($_[0]) =~ /SCALAR/i) {	$flist_ref = $_[0];	}
	else {	$flist_ref = \$_[0];	}
	
	if ($$flist_ref !~ /^\x89\x50\x4E\x47\x0d\x0a\x1a\x0a/) {	return ('', '');	}
	
	@yoko = unpack('C4', substr($$flist_ref, 16, 4));
	@tate = unpack('C4', substr($$flist_ref, 20, 4));
	
	$yoko[3] += ($yoko[2] * 256) + ($yoko[1] * 65536) + ($yoko[0] * 16777216);
	$tate[3] += ($tate[2] * 256) + ($tate[1] * 65536) + ($tate[0] * 16777216);
	
	return ($yoko[3], $tate[3]);
}


# GIFTCY擾
sub gif_size_get_rtn {
	local(@yoko, @tate, $flist_ref);
	
	if (ref($_[0]) =~ /SCALAR/i) {	$flist_ref = $_[0];	}
	else {	$flist_ref = \$_[0];	}
	
	if ($$flist_ref !~ /^\x47\x49\x46/) {	return ('', '');	}
	
	@yoko = unpack('C2', substr($$flist_ref, 6, 2));
	@tate = unpack('C2', substr($$flist_ref, 8, 2));
	
	$yoko[0] += $yoko[1] * 256;
	$tate[0] += $tate[1] * 256;
	
	return ($yoko[0], $tate[0]);
}


# BMPTCY擾
sub bmp_size_get_rtn {
	local(@yoko, @tate, $flist_ref);
	
	if (ref($_[0]) =~ /SCALAR/i) {	$flist_ref = $_[0];	}
	else {	$flist_ref = \$_[0];	}
	
	if ($$flist_ref !~ /^\x42\x4d/) {	return ('', '');	}
	
	if (substr($$flist_ref, 14, 4) =~ /^\x28\x00\x00\x00$/) {
		@yoko = unpack('C4', substr($$flist_ref, 18, 4));
		@tate = unpack('C4', substr($$flist_ref, 22, 4));
		
		$yoko[0] += ($yoko[1] * 256) + ($yoko[2] * 65536) + ($yoko[3] * 16777216);
		$tate[0] += ($tate[1] * 256) + ($tate[2] * 65536) + ($tate[3] * 16777216);
	} elsif (substr($$flist_ref, 14, 4) =~ /^\x0c\x00\x00\x00$/) {
		@yoko = unpack('C2', substr($$flist_ref, 18, 2));
		@tate = unpack('C2', substr($$flist_ref, 20, 2));
		
		$yoko[0] += $yoko[1] * 256;
		$tate[0] += $tate[1] * 256;
	} else {	return ('', '');	}
	
	return ($yoko[0], $tate[0]);
}


# JPGTCY擾
sub jpg_size_get_rtn {
	local(@yoko, @tate, $flist_ref);
	
	if (ref($_[0]) =~ /SCALAR/i) {	$flist_ref = $_[0];	}
	else {	$flist_ref = \$_[0];	}
	
	if ($$flist_ref !~ /^\xff\xd8/) {	return ('', '');	}
	
	if ($$flist_ref =~ /\xff\xc0...(..)(..)/) {
		@tate = unpack('C2', $1);
		@yoko = unpack('C2', $2);
		
		$yoko[1] += $yoko[0] * 256;
		$tate[1] += $tate[0] * 256;
	} else {	return ('', '');	}
	
	return ($yoko[1], $tate[1]);
}


1;

__END__

